# Class Matrix2x2F

java.lang.Object
com.io7m.jtensors.core.unparameterized.matrices.Matrix2x2F

All Implemented Interfaces:
  `MatrixComputationalType, Matrix2x2FType, MatrixReadable2x2FType, MatrixReadableFType`

public final class Matrix2x2F extends Object implements Matrix2x2FType
The type of 2x2 `float`-typed matrices.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `Matrix2x2F.Builder`
  Builds instances of type `Matrix2x2F`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static Matrix2x2F.Builder`
  `builder()`
  Creates a builder for `Matrix2x2F`.
  `static Matrix2x2F`
  `copyOf(Matrix2x2FType instance)`
  Creates an immutable copy of a `Matrix2x2FType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `Matrix2x2F` that have equal attribute values.
  `int`
  `hashCode()`
  Computes a hash code from attributes: `r0c0`, `r0c1`, `r1c0`, `r1c1`.
  `static Matrix2x2F`
  `of(float r0c0, float r0c1, float r1c0, float r1c1)`
  Construct a new immutable `Matrix2x2F` instance.
  `float`
  `r0c0()`
  `float`
  `r0c1()`
  `float`
  `r1c0()`
  `float`
  `r1c1()`
  `String`
  `toString()`
  Prints the immutable value `Matrix2x2F` with attribute values.
  `final Matrix2x2F`
  `withR0c0(float value)`
  Copy the current immutable object by setting a value for the `r0c0` attribute.
  `final Matrix2x2F`
  `withR0c1(float value)`
  Copy the current immutable object by setting a value for the `r0c1` attribute.
  `final Matrix2x2F`
  `withR1c0(float value)`
  Copy the current immutable object by setting a value for the `r1c0` attribute.
  `final Matrix2x2F`
  `withR1c1(float value)`
  Copy the current immutable object by setting a value for the `r1c1` attribute.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface MatrixReadable2x2FType

  `rowColumn`

- ## Method Details

  - ### r0c0

    public float r0c0()
    Specified by:
      `r0c0` in interface `Matrix2x2FType`
    Specified by:
      `r0c0` in interface `MatrixReadable2x2FType`
    Returns:
      The value at row 0 column 0

  - ### r0c1

    public float r0c1()
    Specified by:
      `r0c1` in interface `Matrix2x2FType`
    Specified by:
      `r0c1` in interface `MatrixReadable2x2FType`
    Returns:
      The value at row 0 column 1

  - ### r1c0

    public float r1c0()
    Specified by:
      `r1c0` in interface `Matrix2x2FType`
    Specified by:
      `r1c0` in interface `MatrixReadable2x2FType`
    Returns:
      The value at row 1 column 0

  - ### r1c1

    public float r1c1()
    Specified by:
      `r1c1` in interface `Matrix2x2FType`
    Specified by:
      `r1c1` in interface `MatrixReadable2x2FType`
    Returns:
      The value at row 1 column 1

  - ### withR0c0

    public final Matrix2x2F withR0c0(float value)
    Copy the current immutable object by setting a value for the `r0c0` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for r0c0
    Returns:
      A modified copy or the `this` object

  - ### withR0c1

    public final Matrix2x2F withR0c1(float value)
    Copy the current immutable object by setting a value for the `r0c1` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for r0c1
    Returns:
      A modified copy or the `this` object

  - ### withR1c0

    public final Matrix2x2F withR1c0(float value)
    Copy the current immutable object by setting a value for the `r1c0` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for r1c0
    Returns:
      A modified copy or the `this` object

  - ### withR1c1

    public final Matrix2x2F withR1c1(float value)
    Copy the current immutable object by setting a value for the `r1c1` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for r1c1
    Returns:
      A modified copy or the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `Matrix2x2F` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `r0c0`, `r0c1`, `r1c0`, `r1c1`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `Matrix2x2F` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static Matrix2x2F of(float r0c0, float r0c1, float r1c0, float r1c1)
    Construct a new immutable `Matrix2x2F` instance.
    Parameters:
      `r0c0` - The value for the `r0c0` attribute
      `r0c1` - The value for the `r0c1` attribute
      `r1c0` - The value for the `r1c0` attribute
      `r1c1` - The value for the `r1c1` attribute
    Returns:
      An immutable Matrix2x2F instance

  - ### copyOf

    public static Matrix2x2F copyOf(Matrix2x2FType instance)
    Creates an immutable copy of a `Matrix2x2FType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable Matrix2x2F instance

  - ### builder

    public static Matrix2x2F.Builder builder()
    Creates a builder for `Matrix2x2F`.

        Matrix2x2F.builder()
           .setR0c0(float) // required r0c0
           .setR0c1(float) // required r0c1
           .setR1c0(float) // required r1c0
           .setR1c1(float) // required r1c1
           .build();

    Returns:
      A new Matrix2x2F builder